package mice.cdb.service;

/**
 * Constant values.
 * 
 */
public class ServerConstants {
    /** Name of the MICE_HOME system property. */
    public static final String MICE_HOME_PROPERTY = "MICE_HOME";

    /** location of the server configuration file relative to MICE_HOME. */
    public static final String SERVER_CONFIG_LOCATION = "/etc/cdb-server/cdb.props";

    /** Name of the SERVER_NAME system property. */
    public static final String SERVER_NAME_PROPERTY = "server.name";

    // Logging constants

    /** location of the server configuration file relative to MICE_HOME. */
    public static final String LOG4J_LOCATION = "/etc/cdb-server/log4j.properties";

    /** Interval between reading the log4j.properties file. */
    public static final long LOG4J_INTERVAL_MILLIS = 60000;

    // Database constants
    /** The name of the jdbc property. */
    public static final String DB_JDBC_DRIVER = "db.jdbc";

    /** The name of the database url property. */
    public static final String DB_URL = "db.url";

    /** The name of the database name property. */
    public static final String DB_NAME = "db.name";

    /** The name of the database user name property. */
    public static final String DB_USER = "db.user";

    /** The name of the database user password property. */
    public static final String DB_PWD = "db.pwd";

    /** The name of the database super user name property. */
    public static final String DB_SUPER_USER = "db.superUser";

    /** The name of the database super user password property. */
    public static final String DB_SUPER_PWD = "db.superPwd";

    /** Name of memory pool to watch for running low on memory. */
    public static final String SERVER_POOL_TO_WATCH = "server.poolToWatch";

    // Name of devices
    /** Name of control device **/
    public static final String CONTROL = "CONTROL";

    /** Device type */
    public static final String DETECTOR = "DETECTOR";

    /** Names of detector devices **/
    public static final String[] DETECTORS = { "Ckov A", "Ckov B", "EMR", "KL", "Scalers", "TOF0", "TOF1", "TOF2",
            "Trigger", "Trigger request" };
    /** Device type */
    public static final String TRACKER = "TRACKER";

    /** Names of tracker devices **/
    public static final String[] TRACKERS = { "Tracker 1", "Tracker 2" };

    /** Name of the server. */
    public static final String SERVER_NAME = "serverName";
}
