package mice.cdb.service.beamline;

/**
 * Constants for use by the Beamline.
 * 
 */
public class BeamlineConstants {

    // Constants used for SQL.
    /** Table name. */
    public static final String TABLE_RUN = "run";
    /** Column name. */
    public static final String COLUMN_RUNNUMBER = "runnumber";
    /** Column name. */
    public static final String COLUMN_STARTTIME = "starttime";
    /** Column name. */
    protected static final String COLUMN_ENDTIME = "endtime";
    /** Column name. */
    protected static final String COLUMN_GDC_HOST_NAME = "gdchostname";
    /** Column name. */
    protected static final String COLUMN_START_NOTES = "notes";
    /** Column name. */
    protected static final String COLUMN_END_NOTES = "endnotes";
    /** Column name. */
    protected static final String COLUMN_OPTICS = "optics";
    /** Column name. */
    protected static final String COLUMN_PULSE_START = "pulsestart";
    /** Column name. */
    protected static final String COLUMN_PULSE_END = "pulseend";
    /** Column name. */
    protected static final String COLUMN_STEP = "step";
    /** Column name. */
    protected static final String COLUMN_STATUS = "status";
    /** Column name. */
    protected static final String COLUMN_RUN_TYPE = "runtype";

    /** Table name. */
    protected static final String TABLE_DAQ = "daq";
    /** Column name. */
    protected static final String COLUMN_TRIGGER = "trigger";
    /** Column name. */
    protected static final String COLUMN_GATE_WIDTH = "gatewidth";
    /** Column name. */
    protected static final String COLUMN_VERSION = "version";

    /** Table name. */
    protected static final String TABLE_TARGET = "target";
    /** Column name. */
    protected static final String COLUMN_DEPTH = "depth";
    /** Column name. */
    protected static final String COLUMN_DELAY = "delay";
    /** Column name. */
    protected static final String COLUMN_DRIVE_VOLTAGE = "drivevoltage";

    /** Table name. */
    protected static final String TABLE_BEAMLINE = "beamline";
    /** Column name. */
    protected static final String COLUMN_BEAM_STOP = "beamstop";
    /** Column name. */
    protected static final String COLUMN_DIFFUSER_THICKNESS = "diffuserthickness";
    /** Column name. */
    protected static final String COLUMN_PROTON_ABSORBOR_THICKNESS = "protonabsorberthickness";

    /** Table name. */
    protected static final String TABLE_MAGNET = "magnet";
    /** Column name. */
    protected static final String COLUMN_NAME = "name";
    /** Column name. */
    protected static final String COLUMN_SET_CURRENT = "setcurrent";
    /** Column name. */
    protected static final String COLUMN_POLARITY = "polarity";

    /** Table name. */
    protected static final String TABLE_BEAMLINE_TAGGED = "beamlinetagged";
    /** Column name. */
    protected static final String COLUMN_ID = "id";

    /** Table name. */
    protected static final String TABLE_BEAMLINE_TAG = "beamlinetag";
    /** Column name. */
    protected static final String COLUMN_TAG = "tag";
    /** Column name. */
    protected static final String COLUMN_CREATIONTIME = "creationtime";
    /** Column name. */
    protected static final String COLUMN_VALID_UNTIL_TIME = "validuntiltime";

    /** Table name. */
    protected static final String TABLE_MAGNET_TAGGED = "magnettagged";

    /** Table name. */
    protected static final String TABLE_SCALAR = "scalar";
    /** Column name. */
    protected static final String COLUMN_VALUE = "value";

    /** Table name. */
    protected static final String TABLE_ISIS_BEAM = "isisbeam";
    /** Column name. */
    protected static final String COLUMN_MEAN = "mean";
    /** Column name. */
    protected static final String COLUMN_SIGMA = "sigma";

    /** Table name. */
    protected static final String TABLE_LDC_HOSTS = "ldchosts";

    // Constants used for xml.
    /** XML tag. */
    public static final String RUNS = "runs";
    /** XML tag. */
    public static final String RUN = "run";
    /** XML tag. */
    public static final String END_RUN = "endRun";
    /** XML tag. */
    public static final String START_RUN = "startRun";
    /** XML tag. */
    public static final String BEAMLINE = "beamline";
    /** XML tag. */
    public static final String RUNNUMBER = "runNumber";
    /** XML tag. */
    public static final String STARTTIME = "startTime";
    /** XML tag. */
    public static final String ENDTIME = "endTime";
    /** XML tag. */
    public static final String START_NOTES = "startNotes";
    /** XML tag. */
    public static final String END_NOTES = "endNotes";
    /** XML tag. */
    public static final String OPTICS = "optics";
    /** XML tag. */
    public static final String START_PULSE = "startPulse";
    /** XML tag. */
    public static final String END_PULSE = "endPulse";
    /** XML tag. */
    public static final String STEP = "step";
    /** XML tag. */
    public static final String STATUS = "status";
    /** XML tag. */
    public static final String RUN_TYPE = "runType";
    /** XML tag. */
    public static final String GDC_HOST_NAME = "gdcHostName";
    /** XML tag. */
    public static final String LDC_HOST = "ldcHost";
    /** XML tag. */
    public static final String DEPTH = "targetDepth";
    /** XML tag. */
    public static final String DELAY = "targetDelay";
    /** XML tag. */
    public static final String DRIVE_VOLTAGE = "targetDriveVoltage";
    /** XML tag. */
    public static final String OVERWRITE = "overwrite";
    /** XML tag. */
    public static final String TRIGGER = "daqTrigger";
    /** XML tag. */
    public static final String GATE_WIDTH = "daqGateWidth";
    /** XML tag. */
    public static final String VERSION = "daqVersion";
    /** XML tag. */
    public static final String BEAM_STOP = "beamStop";
    /** XML tag. */
    public static final String DIFFUSER_THICKNESS = "diffuserThickness";
    /** XML tag. */
    public static final String PROTON_ABSORBOR_THICKNESS = "protonAbsorberThickness";
    /** XML tag. */
    public static final String MAGNET = "magnet";
    /** XML tag. */
    public static final String NAME = "name";
    /** XML tag. */
    public static final String SET_CURRENT = "setCurrent";
    /** XML tag. */
    public static final String POLARITY = "polarity";
    /** XML tag. */
    public static final String TAG = "tag";
    /** XML tag. */
    public static final String TAGS = "tags";
    /** XML tag. */
    public static final String TAG_NAMES = "tagNames";
    /** XML tag. */
    public static final String SCALAR = "scalar";
    /** XML tag. */
    public static final String SCALAR_NAME = "name";
    /** XML tag. */
    public static final String SCALAR_VALUE = "value";
    /** XML tag. */
    public static final String ISIS_BEAM = "isisBeam";
    /** XML tag. */
    public static final String ISIS_BEAM_NAME = "name";
    /** XML tag. */
    public static final String MEAN = "mean";
    /** XML tag. */
    public static final String SIGMA = "sigma";

}
