package mice.cdb.service.beamline;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BeamlineData {
    // run data
    private int m_runNumber;
    private Timestamp m_startTime;
    private Timestamp m_endTime;
    private String m_notes;
    private String m_endNotes;
    private String m_optics;
    private int m_pulseStart;
    private int m_pulseEnd;
    private double m_step;
    private boolean m_status;
    private String m_runType;
    private String m_daqTrigger;
    private double m_daqGateWidth;
    private String m_daqVersion;
    private String m_gdcHostName;
    private double m_targetDepth;
    private double m_targetDelay;
    private double m_targetDriveVoltage;
    private Map<String, IsisData> m_isis_beam = new HashMap<String, IsisData>();
    private Map<String, Integer> m_scalar = new HashMap<String, Integer>();
    private List<String> m_ldcHosts = new ArrayList<String>();

    private boolean m_overwrite = false;
    // beamline data
    private boolean m_beamStop;
    private int m_diffuserThickness;
    private int m_protonAbsorberThickness;

    private String m_tag;

    /**
     * @return the runNumber
     */
    public int getRunNumber() {
        return m_runNumber;
    }

    /**
     * @param runNumber
     *            the runNumber to set
     */
    public void setRunNumber(int runNumber) {
        m_runNumber = runNumber;
    }

    /**
     * @return the startTime
     */
    public Timestamp getStartTime() {
        return m_startTime;
    }

    /**
     * @param startTime
     *            the startTime to set
     */
    public void setStartTime(Timestamp startTime) {
        m_startTime = startTime;
    }

    /**
     * @return the endTime
     */
    public Timestamp getEndTime() {
        return m_endTime;
    }

    /**
     * @param endTime
     *            the endTime to set
     */
    public void setEndTime(Timestamp endTime) {
        m_endTime = endTime;
    }

    /**
     * @return the notes
     */
    public String getNotes() {
        return m_notes;
    }

    /**
     * @param notes
     *            the notes to set
     */
    public void setNotes(String notes) {
        m_notes = notes;
    }

    /**
     * @return the end notes
     */
    public String getEndNotes() {
        return m_endNotes;
    }

    /**
     * @param endNotes
     *            the end notes to set
     */
    public void setEndNotes(String endNotes) {
        m_endNotes = endNotes;
    }

    /**
     * @return the optics
     */
    public String getOptics() {
        return m_optics;
    }

    /**
     * @param optics
     *            the optics to set
     */
    public void setOptics(String optics) {
        m_optics = optics;
    }

    /**
     * @return the beamStop
     */
    public boolean getBeamStop() {
        return m_beamStop;
    }

    /**
     * @param beamStop
     *            the beamStop to set
     */
    public void setBeamStop(boolean beamStop) {
        m_beamStop = beamStop;
    }

    /**
     * @return the diffuserThickness
     */
    public int getDiffuserThickness() {
        return m_diffuserThickness;
    }

    /**
     * @param diffuserThickness
     *            the diffuserThickness to set
     */
    public void setDiffuserThickness(int diffuserThickness) {
        m_diffuserThickness = diffuserThickness;
    }

    /**
     * @return the protonAbsorberThickness
     */
    public int getProtonAbsorberThickness() {
        return m_protonAbsorberThickness;
    }

    /**
     * @param protonAbsorberThickness
     *            the protonAbsorberThickness to set
     */
    public void setProtonAbsorberThickness(int protonAbsorberThickness) {
        m_protonAbsorberThickness = protonAbsorberThickness;
    }

    /**
     * @return the pulseStart
     */
    public int getPulseStart() {
        return m_pulseStart;
    }

    /**
     * @param pulseStart
     *            the pulseStart to set
     */
    public void setPulseStart(int pulseStart) {
        m_pulseStart = pulseStart;
    }

    /**
     * @return the pulseEnd
     */
    public int getPulseEnd() {
        return m_pulseEnd;
    }

    /**
     * @param pulseEnd
     *            the pulseEnd to set
     */
    public void setPulseEnd(int pulseEnd) {
        m_pulseEnd = pulseEnd;
    }

    /**
     * @return the step
     */
    public double getStep() {
        return m_step;
    }

    /**
     * @param step
     *            the step to set
     */
    public void setStep(double step) {
        m_step = step;
    }

    /**
     * @return the status
     */
    public boolean getStatus() {
        return m_status;
    }

    /**
     * @param status
     *            the status to set
     */
    public void setStatus(boolean status) {
        m_status = status;
    }

    /**
     * @return the runType
     */
    public String getRunType() {
        return m_runType;
    }

    /**
     * @param runType
     *            the runType to set
     */
    public void setRunType(String runType) {
        m_runType = runType;
    }

    /**
     * @return the daqTrigger
     */
    public String getDaqTrigger() {
        return m_daqTrigger;
    }

    /**
     * @param daqTrigger
     *            the daqTrigger to set
     */
    public void setDaqTrigger(String daqTrigger) {
        m_daqTrigger = daqTrigger;
    }

    /**
     * @return the daqGateWidth
     */
    public double getDaqGateWidth() {
        return m_daqGateWidth;
    }

    /**
     * @param daqGateWidth
     *            the daqGateWidth to set
     */
    public void setDaqGateWidth(double daqGateWidth) {
        m_daqGateWidth = daqGateWidth;
    }

    /**
     * @return the daqVersion
     */
    public String getDaqVersion() {
        return m_daqVersion;
    }

    /**
     * @param daqVersion
     *            the daqVersion to set
     */
    public void setDaqVersion(String daqVersion) {
        m_daqVersion = daqVersion;
    }

    /**
     * @return the gdcHostName
     */
    public String getGdcHostName() {
        return m_gdcHostName;
    }

    /**
     * @param gdcHostName
     *            the gdcHostName to set
     */
    public void setGdcHostName(String gdcHostName) {
        m_gdcHostName = gdcHostName;
    }

    /**
     * @return the targetDepth
     */
    public double getTargetDepth() {
        return m_targetDepth;
    }

    /**
     * @param targetDepth
     *            the targetDepth to set
     */
    public void setTargetDepth(double targetDepth) {
        m_targetDepth = targetDepth;
    }

    /**
     * @return the targetDelay
     */
    public double getTargetDelay() {
        return m_targetDelay;
    }

    /**
     * @param targetDelay
     *            the targetDelay to set
     */
    public void setTargetDelay(double targetDelay) {
        m_targetDelay = targetDelay;
    }

    /**
     * @return the targetDriveVoltage
     */
    public double getTargetDriveVoltage() {
        return m_targetDriveVoltage;
    }

    /**
     * @param targetDriveVoltage
     *            the targetDriveVoltage to set
     */
    public void setTargetDriveVoltage(double targetDriveVoltage) {
        m_targetDriveVoltage = targetDriveVoltage;
    }

    /**
     * @return the tag
     */
    public String getTag() {
        return m_tag;
    }

    /**
     * @param tag
     *            the tag to set
     */
    public void setTag(String tag) {
        m_tag = tag;
    }

    /**
     * @return the overwrite flag
     */
    public boolean getOverwrite() {
        return m_overwrite;
    }

    /**
     * @param overwrite
     *            the overwrite to set
     */
    public void setOverwrite(boolean overwrite) {
        m_overwrite = overwrite;
    }

    /**
     * @return the map of scalars
     */
    public Map<String, Integer> getScalar() {
        return m_scalar;
    }

    /**
     * @param name
     * @param value
     */
    public void addScalar(String name, int value) {
        m_scalar.put(name, value);
    }

    /**
     * @return the map of isis_beam
     */
    public Map<String, IsisData> getIsisBeam() {
        return m_isis_beam;
    }

    /**
     * @param name
     * @param value
     */
    public void addIsisBeam(String name, IsisData value) {
        m_isis_beam.put(name, value);
    }

    /**
     * @return the list of ldc hosts
     */
    public List<String> getLcdHosts() {
        return m_ldcHosts;
    }

    /**
     * @param name
     */
    public void addLdcHost(String name) {
        m_ldcHosts.add(name);
    }

}
