package mice.cdb.service.cabling;

import mice.cdb.service.ServerConstants;

/**
 * Constants for use by the Cabling.
 * 
 */
public class CablingConstants extends ServerConstants {

    // Constants used for SQL.

    // Common columns
    /** Column name. */
    public static final String COLUMN_CHANNEL = "channel";
    /** Column name. */
    public static final String COLUMN_CREATIONTIME = "creationtime";
    /** Column name. */
    public static final String COLUMN_VALID_UNTIL_TIME = "validuntiltime";

    /** Table name. */
    public static final String TABLE_CABLING_CONTROL = "cablingcontrol";
    /** Column name. */
    public static final String COLUMN_CRATE = "crate";
    /** Column name. */
    public static final String COLUMN_MODULE = "module";
    /** Column name. */
    public static final String COLUMN_NAME = "name";

    // More common columns
    /** Column name. */
    protected static final String COLUMN_DEVICE = "device";
    /** Column name. */
    protected static final String COLUMN_STATION = "station";
    /** Column name. */
    protected static final String COLUMN_PLANE = "plane";

    /** Table name. */
    protected static final String TABLE_CABLING_DETECTOR = "cablingdetector";
    /** Column name. */
    protected static final String COLUMN_VALID_FROM_TIME = "validfromtime";
    /** Column name. */
    protected static final String COLUMN_DATA = "data";
    /** Column name. */
    protected static final String COLUMN_ID = "id";

    /** Column name. */
    protected static final String COLUMN_COMPUTER_ID = "computerid";
    /** Column name. */
    protected static final String COLUMN_GEO_NUMBER = "geonumber";
    /** Column name. */
    protected static final String COLUMN_DC = "dc";
    /** Column name. */
    protected static final String COLUMN_SLAB = "slab";
    /** Column name. */
    protected static final String COLUMN_PMT = "pmt";

    /** Table name. */
    protected static final String TABLE_CABLING_TRACKER = "cablingtracker";
    /** Column name. */
    protected static final String COLUMN_VLSB_COMPUTER_ID = "vlsbcomputerid";
    /** Column name. */
    protected static final String COLUMN_VLSB_GEO_NUMBER = "vlsbgeonumber";
    /** Column name. */
    protected static final String COLUMN_VLSB_CHANNEL = "vlsbchannel";
    /** Column name. */
    protected static final String COLUMN_TRACKER_NO = "trackernumber";

    // Constants used by the parser.
    /** XML tag. */
    public static final String CABLING = "cabling";
    /** XML tag. */
    protected static final String DEVICE = "device";
    /** XML tag. */
    protected static final String CRATE = "crate";
    /** XML tag. */
    protected static final String MODULE = "module";
    /** XML tag. */
    public static final String CHANNEL = "channel";
    /** XML tag. */
    protected static final String NAME = "name";
    /** XML tag. */
    protected static final String NUMBER = "number";
    /** XML tag. */
    public static final String VLSB_COMPUTER_ID = "vlsbComputerId";
    /** XML tag. */
    public static final String VLSB_GEO_NUMBER = "vlsbGeoNumber";
    /** XML tag. */
    public static final String VLSB_CHANNEL = "vlsbChannel";
    /** XML tag. */
    public static final String TRACK_NO = "trackerNumber";
    /** XML tag. */
    public static final String STATION = "station";
    /** XML tag. */
    public static final String PLANE = "plane";
    /** XML tag. */
    protected static final String DEVICE_LIST = "deviceList";
    /** XML tag. */
    protected static final String TYPE = "type";

    protected static final String ADD = "add";
    protected static final String UPDATE = "update";

}
