package mice.cdb.service.calibration;

import mice.cdb.service.ServerConstants;

/**
 * Constants for use by the Calibration.
 * 
 */
public class CalibrationConstants extends ServerConstants {

    // Constants used for SQL.

    // Common columns
    /** Column name. */
    protected static final String COLUMN_CREATIONTIME = "creationtime";
    /** Column name. */
    protected static final String COLUMN_DEVICE = "device";

    // Tracker
    /** Table name. */
    protected static final String TABLE_CALIBRATION_TRACKER = "calibrationtracker";
    /** Column name. */
    protected static final String COLUMN_BOARD = "board";
    /** Column name. */
    protected static final String COLUMN_BANK = "bank";
    /** Column name. */
    protected static final String COLUMN_CHANNEL = "channel";
    /** Column name. */
    protected static final String COLUMN_ADC_PEDESTAL = "adcpedestal";
    /** Column name. */
    protected static final String COLUMN_ADC_GAIN = "adcgain";
    /** Column name. */
    protected static final String COLUMN_TDC_PEDESTAL = "tdcpedestal";
    /** Column name. */
    protected static final String COLUMN_TDC_SLOPE = "tdcslope";
    /** Column name. */
    protected static final String COLUMN_VALID_UNTIL_TIME = "validuntiltime";

    // Detector
    /** Table name. */
    protected static final String TABLE_CALIBRATION_DETECTOR = "calibrationdetector";
    /** Column name. */
    protected static final String COLUMN_TYPE = "type";
    /** Column name. */
    protected static final String COLUMN_CALIBRATION = "calibration";
    /** Column name. */
    protected static final String COLUMN_VALID_FROM_TIME = "validfromtime";
    /** Column name. */
    protected static final String COLUMN_DATA = "data";
    /** Column name. */
    protected static final String COLUMN_ID = "id";

    // Constants used by the parser.
    /** XML tag. */
    public static final String CALIBRATIONS = "calibrations";
    /** XML tag. */
    protected static final String CALIBRATION = "calibration";
    /** XML tag. */
    protected static final String DEVICE = "device";
    /** XML tag. */
    public static final String ID = "id";
    /** XML tag. */
    protected static final String NAME = "name";
    /** XML tag. */
    protected static final String NUMBER = "number";
    /** XML tag. */
    public static final String BOARD = "board";
    /** XML tag. */
    public static final String BANK = "bank";
    /** XML tag. */
    public static final String CHANNEL = "channel";
    /** XML tag. */
    public static final String ADC_PEDESTAL = "adcPedestal";
    /** XML tag. */
    public static final String ADC_GAIN = "adcGain";
    /** XML tag. */
    public static final String TDC_PEDESTAL = "tdcPedestal";
    /** XML tag. */
    public static final String TDC_SLOPE = "tdcSlope";
    /** XML tag. */
    protected static final String DEVICE_LIST = "deviceList";
    /** XML tag. */
    protected static final String TYPE = "type";

    protected static final String ADD = "add";
    protected static final String UPDATE = "update";

}
