package mice.cdb.service;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import utils.RTest;

public class ValidatorTest extends RTest {

    private Validator m_validator = new Validator();

    @BeforeClass
    public static void createTables() throws Exception {
        startOfTestClass(ValidatorTest.class);
        testClassReady();
    }

    @After
    public void a1_After() {
        endOfTest();
    }

    @AfterClass
    public static void a1_AfterClass() {
        endOfTestClass();
    }

    @Test
    public final void validateStringNonBlank() throws Exception {
        m_validator.validateStringNonBlank("a");
        m_validator.validateStringNonBlank("Z");
        m_validator.validateStringNonBlank("0");
        m_validator.validateStringNonBlank(":");
        m_validator.validateStringNonBlank("/");
        m_validator.validateStringNonBlank("_");
        m_validator.validateStringNonBlank(".");
        m_validator.validateStringNonBlank("-");
        m_validator.validateStringNonBlank("+");
        m_validator.validateStringNonBlank("=");
        m_validator.validateStringNonBlank("~");
        m_validator.validateStringNonBlank("%");
        m_validator.validateStringNonBlank("3-140-M0");
        m_validator.validateStringNonBlank("3+140-M0 ");
    }

    @Test
    public final void validateString() throws Exception {
        m_validator.validateString(null);
        m_validator.validateString("");
        m_validator.validateString("a");
        m_validator.validateString("Z");
        m_validator.validateString("0");
        m_validator.validateString(":");
        m_validator.validateString("/");
        m_validator.validateString("_");
        m_validator.validateString(".");
        m_validator.validateString("-");
        m_validator.validateString("+");
        m_validator.validateString("=");
        m_validator.validateStringNonBlank("~");
        m_validator.validateString("%");
        m_validator.validateString("3-140-M0");
        m_validator.validateString("3+140-M0 ");
    }
}
