package mice.cdb.service.alarmhandler;

import static org.junit.Assert.assertEquals;

import java.sql.Timestamp;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import utils.RTest;
import utils.TestSetup;

public class AlarmHandlerSMEmptyTest extends RTest {

    mice.cdb.service.ServerConfig m_serverConfig;

    private static AlarmHandlerSuperMouse m_ah;

    @BeforeClass
    public static void createTables() throws Exception {
        startOfTestClass(AlarmHandlerSMEmptyTest.class);
        TestSetup.initializeServer();
        m_ah = new AlarmHandlerSuperMouseImpl();
        testClassReady();
    }

    @After
    public void a1_After() {
        endOfTest();
    }

    @AfterClass
    public static void a1_AfterClass() {
        endOfTestClass();
    }

    @Test
    public final void testGetStatus() throws Exception {
        String result = m_ah.getStatus();
        assertEquals("Status", "<ok>OK</ok>", result);
    }

    @Test
    public final void testListTags() throws Exception {
        String result = m_ah.listTags();
        assertEquals("Tags", "<tags></tags>", result);
    }

    @Test
    public final void testGetTaggedALH() throws Exception {
        String result = m_ah.getTaggedALH("unknown");
        assertEquals("List of tags", "<error>No match found for tag = unknown.</error>", result);
    }

    @Test
    public final void testGetUsedALH() throws Exception {
        String timestamp = new Timestamp(System.currentTimeMillis()).toString();
        String result = m_ah.getUsedALH(timestamp);
        assertEquals("Tags", "<error>Starttime: " + timestamp + " out of range of values in the database.</error>",
                result);
    }

    @Test
    public final void testGetUsedTags() throws Exception {
        String startTimestamp = new Timestamp(0).toString();
        String stopTimestamp = new Timestamp(System.currentTimeMillis()).toString();
        String result = m_ah.getUsedTags(startTimestamp, stopTimestamp);
        assertEquals("Tags", "<tags></tags>", result);
    }

}
