package mice.cdb.service.geometry;

import static org.junit.Assert.assertEquals;

import java.sql.Timestamp;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import utils.RTest;
import utils.TestSetup;

public class GeometryEmptyTest extends RTest {

    mice.cdb.service.ServerConfig m_serverConfig;

    private static Geometry m_geometry;

    @BeforeClass
    public static void createTables() throws Exception {
        startOfTestClass(GeometryEmptyTest.class);
        TestSetup.initializeServer();
        m_geometry = new GeometryImpl();
        testClassReady();
    }

    @After
    public void a1_After() {
        endOfTest();
    }

    @AfterClass
    public static void a1_AfterClass() {
        endOfTestClass();
    }

    @Test
    public final void testGetStatus() throws Exception {
        String result = m_geometry.getStatus();
        assertEquals("Status", "<ok>OK</ok>", result);
    }

    @Test
    public final void testGetIds() throws Exception {
        String timestamp = new Timestamp(System.currentTimeMillis()).toString();
        String result = m_geometry.getIds(timestamp, null);
        assertEquals("Ids", "<ids></ids>", result);
        result = m_geometry.getIds(timestamp, timestamp);
        assertEquals("Ids", "<ids></ids>", result);
    }

    @Test
    public final void testCurrentGDML() throws Exception {
        String result = new String(m_geometry.getCurrentGDML());
        assertEquals("GDML error", "<error>No data returned from the database.</error>", result);
    }

    @Test
    public final void testgetGDMLForId() throws Exception {
        String id = "5";
        String result = new String(m_geometry.getGDMLForId(id));
        assertEquals("GDML error", "<error>No GDML found for id:" + id + "</error>", result);
    }

    @Test
    public final void testGDMLForRun() throws Exception {
        String runNo = "2";
        String result = new String(m_geometry.getGDMLForRun(runNo));
        assertEquals("GDML error", "<error>Run " + runNo + " not found.</error>", result);
    }

}
