package utils;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;

import mice.cdb.service.ServerConfig;
import mice.cdb.service.ServerConstants;

public class LoadData {

    public static final String TEST_LOGGER = "tests";

    public static void insert() throws Exception {

        Statement statement = null;
        Connection connection = null;
        ServerConfig serverConfig = ServerConfig.getInstance();
        String JDBC_DRIVER = serverConfig.getProperty(ServerConstants.DB_JDBC_DRIVER);

        try {
            Class.forName(JDBC_DRIVER);

            String url = serverConfig.getProperty(ServerConstants.DB_URL);
            String db = serverConfig.getProperty(ServerConstants.DB_NAME);
            String smUser = serverConfig.getProperty(ServerConstants.DB_SUPER_USER);
            String smPassword = serverConfig.getProperty(ServerConstants.DB_SUPER_PWD);

            connection = DriverManager.getConnection(url + db, smUser, smPassword);
            statement = connection.createStatement();

            String insert = "";

            // AlarmHandler

            // Tag=Fred
            insert = "INSERT INTO alarm (name, hihi, hi, lo, lolo, creationtime, tag) VALUES ('A1', 104.0, 105.0, 102.0, 101.0, '2010-10-25 12:03:03.187', 'Fred');";
            statement.execute(insert);
            insert = "INSERT INTO alarm (name, hihi, hi, lo, lolo, creationtime, tag) VALUES ('A2', 10, 9, 80, 7, '2010-10-25 12:03:03.187', 'Fred');";
            statement.execute(insert);

            // Tag=Harry
            insert = "INSERT INTO alarm (name, hihi, hi, lo, lolo, creationtime, tag) VALUES ('A1', 105.0, 106.0, 103.0, 101.0, '2010-10-31 11:05:03.432', 'Harry');";
            statement.execute(insert);
            insert = "INSERT INTO alarm (name, hihi, hi, lo, lolo, creationtime, tag) VALUES ('A2', 11, 8, 80, 7, '2010-10-31 11:05:03.432', 'Harry');";
            statement.execute(insert);

            insert = "INSERT into alarmhistory (starttime, alarmcreationtime, alarmtag) VALUES ('2010-10-25 14:29:22.791', '2010-10-25 12:03:03.187', 'Fred');";
            statement.execute(insert);
            insert = "INSERT into alarmhistory (starttime, alarmcreationtime, alarmtag) VALUES ('2010-10-26 14:29:22.791', '2010-10-25 12:03:03.187', 'Fred');";
            statement.execute(insert);
            insert = "INSERT into alarmhistory (starttime, alarmcreationtime, alarmtag) VALUES ('2010-10-25 15:29:22.791', '2010-10-31 11:05:03.432', 'Harry');";
            statement.execute(insert);
            insert = "INSERT into alarmhistory (starttime, alarmcreationtime, alarmtag) VALUES ('2010-10-25 16:29:22.791', '2010-10-25 12:03:03.187', 'Fred');";
            statement.execute(insert);

            // Beamline Stuff
            // beamline
            insert = "INSERT into beamline (runnumber, beamStop, diffuserThickness, protonAbsorberThickness) VALUES (1, true, 11, 12);";
            statement.execute(insert);
            insert = "INSERT into beamline (runnumber, beamStop, diffuserThickness, protonAbsorberThickness) VALUES (2, false, 21, 22);";
            statement.execute(insert);
            insert = "INSERT into beamline (runnumber, beamStop, diffuserThickness, protonAbsorberThickness) VALUES (3, true, 31, 32);";
            statement.execute(insert);

            // run
            insert = "INSERT into run (runnumber, starttime, endtime, notes,  endnotes, optics, pulsestart, pulseend, step, runtype, status) VALUES (1, '2010-10-25 16:29:22.791', '2010-10-25 16:39:22.791', 'junk', 'endjunk1', 'opts', 543, 555, 1.5, '01011110101111000101111010111100', true);";
            statement.execute(insert);
            insert = "INSERT into run (runnumber, starttime, endtime, notes,  endnotes, optics, pulsestart, pulseend, step, runtype, status) VALUES (2, '2010-10-26 16:29:22.791', '2010-10-26 16:39:22.791', 'junk', 'endjunk2', 'opts', 666, 777, 1.5, '01011110101111000101111010111100', true);";
            statement.execute(insert);
            insert = "INSERT into run (runnumber, starttime, endtime, notes,  endnotes, optics, pulsestart, pulseend, step, runtype, status) VALUES (3, '2010-10-28 16:29:22.791', '2010-10-28 16:39:22.791', 'junk', 'endjunk3', 'opts', 666, 777, 1.5,'01011110101111000101111010111100', true);";
            statement.execute(insert);

            // daq
            insert = "INSERT into daq (runnumber, trigger, gatewidth, version) VALUES (1, 'TOF-1', 7.4, '3.2.1-42');";
            statement.execute(insert);
            insert = "INSERT into daq (runnumber, trigger, gatewidth, version) VALUES (2, 'TOF-2', 7.4, '3.2.1-42');";
            statement.execute(insert);

            // isis
            insert = "INSERT into isis (runnumber, targetfrequency, reprate, nominalbeamcurrent, nominalbeamloss, beampositionx, beampositiony) VALUES (1, 32, 4.5, 42.8, 0.3, 1, -1);";
            statement.execute(insert);
            insert = "INSERT into isis (runnumber, targetfrequency, reprate, nominalbeamcurrent, nominalbeamloss, beampositionx, beampositiony) VALUES (2, 32, 4.5, 42.8, 0.3, 5, 7);";
            statement.execute(insert);

            // target
            // "INSERT into target (runnumber bigint PRIMARY KEY, depth double precision, delay double precision, drivevoltage double precision) VALUES ();";
            insert = "INSERT into target (runnumber, depth, delay, drivevoltage) VALUES (1, 9.8, 42.1, 240.9);";
            statement.execute(insert);
            insert = "INSERT into target (runnumber, depth, delay, drivevoltage) VALUES (2, 9.8, 42.1, 240.9);";
            statement.execute(insert);

            // "INSERT into magnet (runnumber bigint, name varchar, setcurrent double precision, CONSTRAINT runnumber_name PRIMARY KEY(runnumber, name));");
            insert = "INSERT into magnet (runnumber, name, setcurrent, polarity) VALUES (1, 'q1', 5.9, 1);";
            statement.execute(insert);
            insert = "INSERT into magnet (runnumber, name, setcurrent, polarity) VALUES (1, 'q2', 7.54, -1);";
            statement.execute(insert);
            insert = "INSERT into magnet (runnumber, name, setcurrent, polarity) VALUES (2, 'q1', 5.9, 1);";
            statement.execute(insert);
            insert = "INSERT into magnet (runnumber, name, setcurrent, polarity) VALUES (2, 'q2', 7.54, -1);";
            statement.execute(insert);

            // scalar
            insert = "INSERT into scalar (runnumber, name, value) VALUES (1, 'SumPartTrig', 1);";
            statement.execute(insert);
            insert = "INSERT into scalar (runnumber, name, value) VALUES (1, 'SumReqTrig', 2);";
            statement.execute(insert);
            insert = "INSERT into scalar (runnumber, name, value) VALUES (2, 'SumPartTrig', 6);";
            statement.execute(insert);
            
            // Cabling - control
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime, validuntiltime) VALUES (1, 1, 1, 'c11', '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime, validuntiltime) VALUES (1, 1, 2, 'c12', '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime, validuntiltime) VALUES (1, 2, 1, 'c13', '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime, validuntiltime) VALUES (2, 3, 1, 'c14', '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime) VALUES (1, 1, 1, 'c21', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime) VALUES (1, 1, 2, 'c22', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime) VALUES (1, 2, 1, 'c23', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingcontrol (crate, module, channel, name, creationtime) VALUES (2, 3, 1, 'c24', '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            // Cabling - tracker
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 120, 130, 141, 151, 161, 171, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 121, 130, 142, 152, 162, 172, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 121, 131, 143, 153, 163, 173, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime, validuntiltime) VALUES ('TRACKER 1', 111, 120, 130, 144, 154, 164, 174, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime) VALUES ('TRACKER 1', 210, 220, 230, 241, 251, 261, 271, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime) VALUES ('TRACKER 1', 210, 221, 230, 242, 252, 262, 272, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime) VALUES ('TRACKER 1', 210, 221, 231, 243, 253, 263, 273, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into cablingtracker (device, vlsbcomputerid, vlsbgeonumber, vlsbchannel, trackernumber, station, plane, channel, creationtime) VALUES ('TRACKER 1', 211, 220, 230, 244, 254, 264, 274, '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            // Calibration - tracker
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 120, 130, 141, 151, 161, 171, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 121, 130, 142, 152, 162, 172, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime, validuntiltime) VALUES ('TRACKER 1', 110, 121, 131, 143, 153, 163, 173, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime, validuntiltime) VALUES ('TRACKER 1', 111, 120, 130, 144, 154, 164, 174, '2010-10-25 16:29:22.791', '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime) VALUES ('TRACKER 1', 210, 220, 230, 241, 251, 261, 271, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime) VALUES ('TRACKER 1', 210, 221, 230, 242, 252, 262, 272, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime) VALUES ('TRACKER 1', 210, 221, 231, 243, 253, 263, 273, '2010-10-27 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into calibrationtracker (device, board, bank, channel, adcpedestal, adcgain, tdcpedestal, tdcslope, creationtime) VALUES ('TRACKER 1', 211, 220, 230, 244, 254, 264, 274, '2010-10-27 16:29:22.791');";
            statement.execute(insert);

            // Control
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '1', 'param1', '111', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '1', 'param2', '112', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '1', 'param3', '113', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '1', 'param4', '114', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '1', 'param5', '115', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '2', 'param1', '121', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '2', 'param2', '122', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '2', 'param3', '123', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '2', 'param4', '124', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '1', '2', 'param5', '125', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '2', '1', 'param1', '211', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '2', '1', 'param2', '212', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '2', '1', 'param3', '213', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '2', '1', 'param4', '214', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('1', '2', '1', 'param5', '215', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('2', '3', '1', 'param1', '221', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('2', '3', '1', 'param2', '222', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('2', '3', '1', 'param3', '223', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('2', '3', '1', 'param4', '224', '2010-10-25 16:29:22.791');";
            statement.execute(insert);
            insert = "INSERT into controls (crate, module, channel, parametername, parametervalue, creationtime) VALUES ('2', '3', '1', 'param5', '225', '2010-10-25 16:29:22.791');";
            statement.execute(insert);

            // Geometry
            insert = "INSERT into geometry (validfromtime, gdml, notes, creationtime) VALUES (?, ?, ?, ?);";
            PreparedStatement ps = connection.prepareStatement(insert);
            insertGeometry(ps, "2010-10-25 16:29:22.791", "gdml - 1", "blar 1", "2010-10-25 16:29:22.791");
            insertGeometry(ps, "2010-10-27 16:29:22.791", "gdml - 2", "blar 2", "2010-10-27 16:29:20.791");
            insertGeometry(ps, "2010-10-27 16:29:22.791", "gdml - 3", "blar 3", "2010-10-27 16:29:21.791");
            insertGeometry(ps, "2010-10-25 16:29:22.791", "gdml - 4", "blar 4", "2010-10-27 16:29:22.791");
            insertGeometry(ps, "2010-10-26 16:29:22.791", "gdml - 5", "blar 5", "2010-10-28 16:29:22.791");
            insertGeometry(ps, "2010-10-25 16:29:22.791", "gdml - 6", "blar 6", "2010-10-29 16:29:22.791");
            ps.close();

            statement.close();
            connection.close();
        } catch (Exception e) {
            System.out.println("Problem with inserting data " + e.getMessage());
            throw e;
        } finally {
            if (statement != null) {
                statement.close();
            }

            if (connection != null) {
                connection.close();
            }
        }
    }

    private static void insertGeometry(PreparedStatement ps, String validfromtime, String gdml, String notes,
            String creationtime) throws SQLException {
        ps.setTimestamp(1, Timestamp.valueOf(validfromtime));
        ps.setBytes(2, gdml.getBytes());
        ps.setString(3, notes);
        ps.setTimestamp(4, Timestamp.valueOf(creationtime));
        ps.executeUpdate();
    }

}
